﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class MenuScript : MonoBehaviour {

	//Strings
	public string Header;
	public string[] Variables;
	public string[] Choices1;
	public string[] Choices2;
	public string[] Choices3;

	//GOs
	public GameObject HeaderObj;
	public GameObject[] VariableObj;
	public GameObject[] ChoiceObj;
	public GameObject SubMenu;

	//Images
	public Sprite GrayButton;
	public Sprite SelectedButton;

	//Logic Variables
	public bool inUse = false;	//Needs to be public for Player access
	private bool subMenu = false;
	private int selected = 0;
	private int subSelected = 0;
	private int choice = 0;

	private float activeY;

	// Use this for initialization
	void Start () {
		activeY = transform.position.y;
		MoveUp ();

		HeaderObj.GetComponent<TextMesh> ().text = Header;
		SubMenu.transform.position = new Vector3 (SubMenu.transform.position.x, 10, SubMenu.transform.position.z);
	}

	// Update is called once per frame
	void Update () {
		if (inUse) {
			if (!subMenu) {
				for (int i = 0; i < Variables.Length; i++) {
					VariableObj [i].GetComponent<SpriteRenderer> ().sprite = GrayButton;
				}

				VariableObj [selected].GetComponent<SpriteRenderer> ().sprite = SelectedButton;

				transform.position = new Vector3 (transform.position.x, activeY, transform.position.z);

				//Inputs
				if (Input.GetKeyDown (KeyCode.DownArrow)) {
					if (selected < Variables.Length - 1)
						selected++;
				}

				if (Input.GetKeyDown (KeyCode.UpArrow)) {
					if (selected > 0)
						selected--;
				}

				if (Input.GetKeyDown (KeyCode.Return)) {
					subMenu = true;
					SubMenu.transform.position = new Vector3 (SubMenu.transform.position.x, VariableObj[selected].transform.position.y, 
						SubMenu.transform.position.z);
					if (selected == 0) {
						ChoiceObj [0].transform.Find("Choice").GetComponent<TextMesh> ().text = Choices1 [0];
						ChoiceObj [1].transform.Find("Choice").GetComponent<TextMesh> ().text = Choices1 [1];
						ChoiceObj [2].transform.Find("Choice").GetComponent<TextMesh> ().text = Choices1 [2];
					} else if (selected == 1) {
						ChoiceObj [0].transform.Find("Choice").GetComponent<TextMesh> ().text = Choices2 [0];
						ChoiceObj [1].transform.Find("Choice").GetComponent<TextMesh> ().text = Choices2 [1];
						ChoiceObj [2].transform.Find("Choice").GetComponent<TextMesh> ().text = Choices2 [2];
					} else {
						ChoiceObj [0].transform.Find("Choice").GetComponent<TextMesh> ().text = Choices3 [0];
						ChoiceObj [1].transform.Find("Choice").GetComponent<TextMesh> ().text = Choices3 [1];
						ChoiceObj [2].transform.Find("Choice").GetComponent<TextMesh> ().text = Choices3 [2];
					}
				}

				if (Input.GetKeyDown (KeyCode.Escape)) {	//Close menu
					GameObject Player = GameObject.Find ("Player");
					Player.GetComponent<Player> ().inMenu = false;
					inUse = false;
					MoveUp ();
					selected = 0;
				}
			} else {	//In SubMenu
				for (int i = 0; i < ChoiceObj.Length; i++) {
					ChoiceObj [i].GetComponent<SpriteRenderer> ().sprite = GrayButton;
				}

				ChoiceObj [subSelected].GetComponent<SpriteRenderer> ().sprite = SelectedButton;

				if (Input.GetKeyDown (KeyCode.RightArrow)) {
					if (subSelected < ChoiceObj.Length - 1)
						subSelected++;
				}

				if (Input.GetKeyDown (KeyCode.LeftArrow)) {
					if (subSelected > 0)
						subSelected--;
				}

				if (Input.GetKeyDown (KeyCode.Return)) {
					if (selected == 0) {
						VariableObj [selected].transform.Find ("Choice").GetComponent<TextMesh> ().text = Choices1 [subSelected] + ";";
						if (subSelected == 0)
							GameObject.FindGameObjectWithTag ("Dog").transform.localScale = new Vector3 (5.5f,5.5f,1);
						else if (subSelected == 1)
							GameObject.FindGameObjectWithTag ("Dog").transform.localScale = new Vector3 (11,11,1);
						else
							GameObject.FindGameObjectWithTag ("Dog").transform.localScale = new Vector3 (20,20,1);
					}
					else if (selected == 1)
						VariableObj [selected].transform.Find("Choice").GetComponent<TextMesh> ().text = Choices2 [subSelected] + ";";
					else
						VariableObj [selected].transform.Find("Choice").GetComponent<TextMesh> ().text = Choices3 [subSelected] + ";";

					subSelected = 0;
					subMenu = false;
					SubMenu.transform.position = new Vector3 (SubMenu.transform.position.x, 10, SubMenu.transform.position.z);
				}

				if (Input.GetKeyDown (KeyCode.Escape)) {	//Close menu
					subMenu = false;
					SubMenu.transform.position = new Vector3 (SubMenu.transform.position.x, 10, SubMenu.transform.position.z);
					subSelected = 0;
				}
			}
		}
	}

	void MoveUp(){
		transform.position = new Vector3 (transform.position.x, 10, transform.position.z);
	}
}
